
/******************************************************************************
* MODULE     : to_generic.cc
* DESCRIPTION: conversion of TeXmacs to a generic format
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "convert.hh"

static string
extract_language (tree doc) {
  hashmap<string,tree> init (UNINIT, extract (doc, "initial"));
  if (init->contains (TEXT_LANGUAGE)) return as_string (init [TEXT_LANGUAGE]);
  else return "english";
}

string
tree_to_generic_document (tree doc, string fm) {
  if ((fm == "TeXmacs") || (fm == "help"))
    return tree_to_texmacs_document (doc);
  else if (fm == "scheme")
    return tree_to_scheme_document (doc);
  else if ((fm == "tex") || (fm == "latex")) {
    tree   body = extract (doc, "body");
    tree   style= extract (doc, "style");
    string lan  = extract_language (doc);
    return tree_to_latex_document (body, style, lan);
  }
  else if (fm == "html") {
    tree   body = extract (doc, "body");
    tree   style= extract (doc, "style");
    string lan  = extract_language (doc);
    return tree_to_html_document (body, style, lan);
  }
  else if (fm == "verbatim") {
    tree   body = extract (doc, "body");
    return tree_to_verbatim (body);
  }
  else return "* error: unknown format *";
}
