
/******************************************************************************
* MODULE     : input.hh
* DESCRIPTION: Generic TeXmacs input
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef INPUT_H
#define INPUT_H

struct texmacs_input_rep: concrete_struct {
  int    status;
  path   mode;
  string buf;
  bool   generic_flag;

  tree   channels;
  hashmap<string,tree> docs;

  texmacs_input_rep (string the_mode);
  int  get_mode (string s);
  bool put (char c);
  void bof ();
  void eof ();
  void flush (bool force= false);
  void write (tree t);
  tree get (string channel= "output");

  void verbatim_flush (bool force= false);
  void scheme_flush (bool force= false);
  void latex_flush (bool force= false);
  void html_flush (bool force= false);
  void ps_flush (bool force= false);
  void ispell_flush (bool force= false);
  void channel_flush (bool force= false);
  void command_flush (bool force= false);
};

class texmacs_input {
  CONCRETE(texmacs_input);
  texmacs_input (string the_mode);
};
CONCRETE_CODE(texmacs_input);

tree get_texmacs_input (string in, string fm);

#endif // defined INPUT_H
